searchData={"items":[{"type":"module","title":"OffBroadwayWebSocket.Client","doc":"Provides functions to establish and configure WebSocket connections\nusing the **gun** library, with customizable timeouts and connection options.","ref":"OffBroadwayWebSocket.Client.html"},{"type":"function","title":"OffBroadwayWebSocket.Client.connect/5","doc":"Establishes a WebSocket connection to the specified URL and path with optional **gun** options,\nand customizable timeouts.","ref":"OffBroadwayWebSocket.Client.html#connect/5"},{"type":"function","title":"Parameters - OffBroadwayWebSocket.Client.connect/5","doc":"- **url**: The base URL for the WebSocket connection (e.g., \"wss://example.com\").\n  - **path**: The WebSocket path to upgrade to (e.g., \"/ws\").\n  - **gun_opts**: A map containing :gun configuration.\n  - **await_timeout**: The timeout in milliseconds to wait for the connection to become ready.\n  - **connect_timeout**: The timeout in milliseconds for establishing the connection.","ref":"OffBroadwayWebSocket.Client.html#connect/5-parameters"},{"type":"function","title":"Returns - OffBroadwayWebSocket.Client.connect/5","doc":"- **{:ok, %{conn_pid: pid(), stream_ref: reference()}}** on a successful connection and upgrade.\n  - **{:error, reason}** if the connection or upgrade fails.","ref":"OffBroadwayWebSocket.Client.html#connect/5-returns"},{"type":"module","title":"OffBroadwayWebSocket.Producer","doc":"A GenStage producer that manages WebSocket connections using the **gun** library.\n\nThis module establishes a WebSocket connection, and manages message dispatching based on demand. It monitors the\nWebSocket connection with ping/pong messages and terminates connection when timeouts occur.","ref":"OffBroadwayWebSocket.Producer.html"},{"type":"function","title":"OffBroadwayWebSocket.Producer.start_link/1","doc":"Starts the WebSocket producer under a GenStage supervisor.","ref":"OffBroadwayWebSocket.Producer.html#start_link/1"},{"type":"module","title":"OffBroadwayWebSocket.State","doc":"Holds the connection and retry state for a WebSocket producer in an Off-Broadway pipeline.","ref":"OffBroadwayWebSocket.State.html"},{"type":"module","title":"Fields - OffBroadwayWebSocket.State","doc":"- **url**, **path** – Target WebSocket endpoint.\n- **gun_opts** – Options passed directly to Gun for HTTP/WebSocket setup.\n- **ws_timeout** – Idle timeout for WebSocket frames.\n- **await_timeout** – Timeout for synchronous Gun calls.\n- **headers** – HTTP headers for the upgrade.\n- **min_demand**, **max_demand** – Broadway demand settings.\n- **telemetry_id** – ID used when firing telemetry events.\n- **message_queue** – Internal buffer for frames before dispatch.\n- **ws_init_retry_opts**, **ws_retry_opts** – Retry parameters for reconnect logic.\n- **ws_retry_fun** – Function computing delays and next-state.\n- **pid**, **conn_pid**, **stream_ref** – Process and stream tracking.\n- **last_msg_dt**, **queue_size**, **total_demand** – Monitoring and backpressure.","ref":"OffBroadwayWebSocket.State.html#module-fields"},{"type":"function","title":"OffBroadwayWebSocket.State.default_ws_retry_fun/1","doc":"Default function to compute the next reconnect delay and state.","ref":"OffBroadwayWebSocket.State.html#default_ws_retry_fun/1"},{"type":"function","title":"OffBroadwayWebSocket.State.default_ws_retry_opts/0","doc":"The default retry options map used for WebSocket reconnects.","ref":"OffBroadwayWebSocket.State.html#default_ws_retry_opts/0"},{"type":"function","title":"OffBroadwayWebSocket.State.new/1","doc":"Builds a new state struct from the given options.\n\nRequired options:\n- **:url** – WebSocket endpoint\n- **:path** – WebSocket path\n\nOptional:\n- **:gun_opts**, defaults to `%{}`\n- **:ws_timeout**, defaults to `nil`\n- **:await_timeout**, defaults to 10000\n- **:headers**, defaults to `[]`\n- **:telemetry_id**, defaults to :websocket_producer\n- **:broadway**, to customize min_demand/max_demand\n- **:ws_retry_opts**, defaults to default_ws_retry_opts/0","ref":"OffBroadwayWebSocket.State.html#new/1"},{"type":"type","title":"OffBroadwayWebSocket.State.retry_opts/0","doc":"","ref":"OffBroadwayWebSocket.State.html#t:retry_opts/0"},{"type":"type","title":"OffBroadwayWebSocket.State.t/0","doc":"","ref":"OffBroadwayWebSocket.State.html#t:t/0"}],"producer":{"name":"ex_doc","version":"0.38.2"},"proglang":"elixir","content_type":"text/markdown"}